//------------------------------------------------------------------------------------------------+
// Filename: BasicClass.cpp
// Content : {IȃNXQ̒`
//------------------------------------------------------------------------------------------------+

#include"BasicClass.h"


/****************************************** WNX *******************************************/

// Name: operator == -----------------------------------------------------------------------------+
// W̔rs
//------------------------------------------------------------------------------------------------+
bool Coordinate::operator==( Coordinate c ){

	if( x == c.x && y == c.y ) return true;
	return false;
}

// Name: operator != -----------------------------------------------------------------------------+
// W̔rs
//------------------------------------------------------------------------------------------------+
bool Coordinate::operator!=( Coordinate c ){

	if( x != c.x || y != c.y ) return true;
	return false;
}


// Name: operator += -----------------------------------------------------------------------------+
// W̉Zs
//------------------------------------------------------------------------------------------------+
Coordinate& Coordinate::operator +=(Coordinate c){

	x += c.x;
	y += c.y;

	return *this;
}


// Name: operator -= -----------------------------------------------------------------------------+
// W̌Zs
//------------------------------------------------------------------------------------------------+
Coordinate& Coordinate::operator -=(Coordinate c){

	x -= c.x;
	y -= c.y;

	return *this;
}


// Name: operator *= -----------------------------------------------------------------------------+
// W̏Zs
//------------------------------------------------------------------------------------------------+
Coordinate& Coordinate::operator *=( double f ){

	x *= f;
	y *= f;

	return *this;
}


// Name: operator /= -----------------------------------------------------------------------------+
// W̏Zs
//------------------------------------------------------------------------------------------------+
Coordinate& Coordinate::operator /=( double f ){

	x /= f;
	y /= f;

	return *this;
}


// Name: operator + ------------------------------------------------------------------------------+
// W̉Zs
//------------------------------------------------------------------------------------------------+
Coordinate Coordinate::operator +( Coordinate c ){

	return  Coordinate( x + c.x,  y + c.y );
}


// Name: operator - ------------------------------------------------------------------------------+
// W̌Zs
//------------------------------------------------------------------------------------------------+
Coordinate Coordinate::operator -(Coordinate c){

	return Coordinate( x - c.x, y - c.y );
}


// Name: operator * ------------------------------------------------------------------------------+
// W̏Zs
//------------------------------------------------------------------------------------------------+
Coordinate Coordinate::operator *(double f){

	return Coordinate( x*f,  y*f );
}


// Name: operator / ------------------------------------------------------------------------------+
// W̏Zs
//------------------------------------------------------------------------------------------------+
Coordinate Coordinate::operator /(double f){

	return Coordinate( x/f,  y/f );
}


// Name: operator - ------------------------------------------------------------------------------+
// }CiX̍W
//------------------------------------------------------------------------------------------------+
Coordinate Coordinate::operator -(){

	return Coordinate( -x, -y );
}
