//------------------------------------------------------------------------------------------------+
// Filename: GlobalMap.h
// Content : n}֘ANX̒`
//------------------------------------------------------------------------------------------------+
#ifndef GLOBALMAP_H__
#define GLOBALMAP_H__

#include <stdio.h>
#include "cv.h"
#include "highgui.h"
#include <stdlib.h>
#include <time.h>
#define _USE_MATH_DEFINES
#include <math.h>
#include <algorithm>
#include "LocalMap.h"

#include <vector>
#include <iostream>


//------------------------------------------------------------------------------------------------+
// p[eBN
// {bg̈ʒuƖޓx
//------------------------------------------------------------------------------------------------+
class Particle{
public:
	double x;
	double y;
	double th;
	double sum_likelihood;		// ݐϖޓx

	Particle(){
		sum_likelihood = 0.0;
	}
};


//------------------------------------------------------------------------------------------------+
// n}NX
//------------------------------------------------------------------------------------------------+
class GlobalMap{ 
private:
	double scale_x, scale_y;
	double origin_x, origin_y;

public:
	vector<vector<int>>	map;

	GlobalMap( int x_size, int y_size, double x_scale, double y_scale, double x_origin, double y_origin ){

		scale_x  = x_scale;
		scale_y  = y_scale;
		origin_x = x_origin;
		origin_y = y_origin;

		map.resize( x_size );
		for( int i=0; i<x_size; i++ ) map[i].resize( y_size );

	}

	double Likelihood( LocalMap* localmap, double x, double y, double th );
};


#endif // GLOBALMAP_H__
