//------------------------------------------------------------------------------------------------+
// Filename: SLAMIO.h
// Content : SLAMɓo͂f[^NX̒`
//------------------------------------------------------------------------------------------------+
#ifndef __SLAMIO
#define __SLAMIO

#include "BasicClass.h"
#include "cv.h"
#include "highgui.h"


//------------------------------------------------------------------------------------------------+
// SLAM̂߂̓̓NX
//------------------------------------------------------------------------------------------------+
class SLAMinput{

protected:
	IplImage *image;
	StereoData stereo;
	Pose pose;
	RangeData range;

	bool image_updated, stereo_updated, pose_updated, lrf_updated;

public:
	SLAMinput();
	virtual ~SLAMinput();
	bool IsNewImage(){ return image_updated; }
	bool IsNewStereo(){ return stereo_updated; }
	bool IsNewPose(){ return pose_updated; }
	bool IsNewLRFData(){ return lrf_updated; }
	bool IsNewAnyData(){ return ( image_updated || stereo_updated || pose_updated || lrf_updated ); }

	IplImage *Image();		// 摜f[^Ԃ
	StereoData Stereo();	// XeIf[^Ԃ
	Pose RobotPose();		// {bgʒuEpf[^Ԃ
	RangeData LRFdata();	// [Uf[^Ԃ

	void SetData( IplImage *data );		// 摜f[^Zbg
	void SetData( StereoData data );	// XeIf[^Zbg
	void SetData( Pose data );			// {bgʒuEpf[^Zbg
	void SetData( RangeData data );		// [Uf[^Zbg
};


//------------------------------------------------------------------------------------------------+
// SLAMɃÕf[^͂邽߂̃NX
//------------------------------------------------------------------------------------------------+
class SLAMinputFromLog : public SLAMinput{

	int data_number;

public:
	SLAMinputFromLog();
	bool DataUpdate();							// ̃f[^ǂݍōXV

private:
	IplImage *GetImage( int time );				// w莞Ԃ̉摜t@Cǂݍ
	StereoData ReadStereoData( int time );		// w莞Ԃ̃XeIf[^t@Cǂݍ
	Pose ReadPose( int time );					// w莞Ԃ̈ʒuf[^t@Cǂݍ
	RangeData ReadRangeData( int time );		// w莞Ԃ̋f[^t@Cǂݍ
};


#endif	// __SLAMIO
