//------------------------------------------------------------------------------------------------+
// Filename: KSLAM.h
// Content : SLAMs֐̒`Ȃ
//------------------------------------------------------------------------------------------------+
#ifndef __KSLAM
#define __KSLAM

#include "edit_map.h"
#include "BasicClass.h"
#include "SLAMinput.h"
#include <time.h>
#define old 0
#include <float.h>
#include <vector>


//------------------------------------------------------------------------------------------------+
// }N̒`
//------------------------------------------------------------------------------------------------+
#define REUSE_STACK_SIZE	10000		// n}p[cėpX^bN̑傫
#define	MAX_RANGE			30000		// [UZT̎擾\ő勗


//------------------------------------------------------------------------------------------------+
// kSLAMNX
//------------------------------------------------------------------------------------------------+
class KSLAM{

	int particle_num;			// p[eBN
	bool first_flag;			// 񌟏optO
	int current_time;
	bool show_result;			// ʂ\邩
	bool save_image;			// ꂽ摜ۑ邩

	SLAMinput *input;

	// 摜p[cXgp
	std::vector<Gmap_Piece> GPiece;				//n}̃p[c̃Xgp
	Gmap_Piece* delete_P[REUSE_STACK_SIZE];		//n}p[cėpX^bNiꎞۊǏꏊj

	int delete_P_count;			//n}p[cėpX^bN|C^
	Gmap_Piece* first_P;		//X^bNXg̐擪|C^
	Gmap_Piece* end_P;			//X^bNXg̍Ō|C^
	int Piece_num;				//n}p[c̑@iep[eBNgĂp[cj
	LocalMap *local_map;		//Ǐn}̃NXi[Ű̌`ɕϊj

	// p[eBNp
	GlobalMap *GrobalMap_L;		// n}NX@p[eBN\
	double sum_likelihood, max_likelihood;
	std::vector<int> resample;

	Pose world, old_world;		//݂̃IhgƈÕIhg

	IplImage *GMAP;				//ʉ摜p

public:

	KSLAM( int particle_num, SLAMinput *input, bool save_image=true, bool show_result=true, GlobalMap *g_map=0 );
	~KSLAM();
	KSLAM( const KSLAM& obj ){ throw; }
	void Mapping();							// n}s1Xebv
	void SaveData();						// Obhn}EoHEh}[Nn}̕ۑ
	IplImage *GlobalMapImage();				// n}摜Ԃ
	Coordinate GlobalMapOrigin();			// n}̌_(0,0)̍WԂ
	Pose EstimatedPose();					// Ȉʒu茋ʂԂ

private:
	int GetBestGlobalMap();							// łޓx̍p[eBNT
	void SaveMapImage();							// Obhn}摜Ƃĕۑ
	void SaveMapDataText();							// Obhn}eLXgf[^Ƃĕۑ
	void SavePathData();							// oHeLXgf[^Ƃĕۑ
	void SaveLandmarkMap();							// h}[Nn}eLXgf[^Ƃĕۑ
	vector<bool> CheckEffective( int num, feature *features );		// oꂽSIFTLǂ̃`FbN
	vector<z_struct_3> MatchingLandmarkAndSIFT( int num, feature *features, vector<bool> effective, StereoData stereo );	// SIFTƃh}[N̑Ήf[^Ԃ
	void Predict( bool first_loop=false );			// p[eBNɈړʂ^
	void UpdateGlobalMap( int current_time, vector<z_struct_3> z_data );					// p[eBNin}j̍XV
	void UpdateGlobalMap( int current_time );		// p[eBNin}j̍XV
	void Likelihood( vector<z_struct_3> z_data );	// p[eN̖ޓxvZ
	void Resampling();								// p[eBN̂܂
	void UpdateMapPiece();							// n}p[c̃Xg̍XV@{0̃p[cXg珜O
	void ShowImage( int current_time, IplImage *raw, int num, feature *features, vector<bool> effective, StereoData stereo, vector<z_struct_3> z_data );		// \p̉摜𐶐
	IplImage *MakeStereoImage( StereoData stereo );	// XeI摜̍쐬
};


#endif	//__KSLAM
